{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfangcurii/bcbioarvados"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": "python",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#generateBamList.cwl/bams"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    },
                    "id": "#generateBamList.cwl/pythonGenerate"
                }
            ],
            "id": "#generateBamList.cwl",
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "*"
                    },
                    "id": "#generateBamList.cwl/textFiles"
                }
            ]
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfangcurii/bcbioarvados"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#main/bamDirectory"
                },
                {
                    "type": "File",
                    "id": "#main/generateBamListScript"
                },
                {
                    "type": "File",
                    "id": "#main/mergeBamScript"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#main/merge/mergedBams",
                    "id": "#main/mergedBamDirectory"
                }
            ],
            "steps": [
                {
                    "run": "#generateBamList.cwl",
                    "in": [
                        {
                            "source": "#main/bamDirectory",
                            "id": "#main/generateBamList/bams"
                        },
                        {
                            "source": "#main/generateBamListScript",
                            "id": "#main/generateBamList/pythonGenerate"
                        }
                    ],
                    "out": [
                        "#main/generateBamList/textFiles"
                    ],
                    "id": "#main/generateBamList"
                },
                {
                    "run": "#mergeSamtools.cwl",
                    "scatter": [
                        "#main/merge/name"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "source": "#main/mergeBamScript",
                            "id": "#main/merge/mergeScript"
                        },
                        {
                            "source": "#main/readBamList/names",
                            "id": "#main/merge/name"
                        }
                    ],
                    "out": [
                        "#main/merge/mergedBams"
                    ],
                    "id": "#main/merge"
                },
                {
                    "run": "#readBamList.cwl",
                    "in": [
                        {
                            "source": "#main/generateBamList/textFiles",
                            "id": "#main/readBamList/bamTexts"
                        }
                    ],
                    "out": [
                        "#main/readBamList/names"
                    ],
                    "id": "#main/readBamList"
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfangcurii/bcbioarvados"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "outputDirType": "keep_output_dir",
                    "keep_cache": 4096,
                    "class": "http://arvados.org/cwl#RuntimeConstraints"
                }
            ],
            "baseCommand": "python",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#mergeSamtools.cwl/mergeScript"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#mergeSamtools.cwl/name"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*"
                    },
                    "id": "#mergeSamtools.cwl/mergedBams"
                }
            ],
            "id": "#mergeSamtools.cwl"
        },
        {
            "class": "ExpressionTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#readBamList.cwl/bamTexts"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#readBamList.cwl/names"
                }
            ],
            "expression": "${ var bamNameFiles = []; for (var i = 0; i < inputs.bamTexts.listing.length; i++) { var name = inputs.bamTexts.listing[i]; var location = name.location; var basename = name.basename; if (basename.indexOf('txt') !== -1) { bamNameFiles.push(name); } } return {'names': bamNameFiles}; }",
            "id": "#readBamList.cwl"
        }
    ],
    "cwlVersion": "v1.0",
    "$namespaces": {
        "arv": "http://arvados.org/cwl#",
        "cwltool": "http://commonwl.org/cwltool#"
    }
}
